module.exports = function (config) {
  var express = require('express')
  var proxyMiddleware = require('http-proxy-middleware')
// default port where dev server listens for incoming traffic
  var port = process.env.PORT || config.server.port
// Define HTTP proxies to your custom API backend
// https://github.com/chimurai/http-proxy-middleware
  var proxyTable = config.server.proxyTable

  var app = express()

// proxy api requests
  Object.keys(proxyTable).forEach(function (context) {
    var options = proxyTable[context]
    if (typeof options === 'string') {
      options = {target: options}
    }
    app.use(proxyMiddleware(context, options))
  })

// handle fallback for HTML5 history API
  app.use(require('connect-history-api-fallback')({}))

  app.get('/index.html', function (req, res) {
    res.sendFile(require('path').join(__dirname, './index.html'))
  })

// serve pure static assets
  app.use('/static', express.static('./static'))

  app.listen(port, function (err) {
    if (err) {
      console.log(err)
      return
    }
    console.log('Listening at http://localhost:' + port + '\n')
  })
}

