var webpack = require('webpack')
var merge = require('webpack-merge')
var HtmlWebpackPlugin = require('html-webpack-plugin')
var utils = require('./utils')

module.exports = function (config) {

  // base webpack config
  var buildWebpackBase = require('./build-webpack-base')
  var baseWebpackConfig = buildWebpackBase(config)

// add hot-reload related code to entry chunks
  Object.keys(baseWebpackConfig.entry).forEach(function (name) {
    baseWebpackConfig.entry[name] = ['./build/dev-client'].concat(baseWebpackConfig.entry[name])
  })

  return merge(baseWebpackConfig, {
    module: {
      loaders: utils.styleLoaders()
    },
    // eval-source-map is faster for development
    devtool: '#eval-source-map',
    plugins: [
      // https://github.com/glenjamin/webpack-hot-middleware#installation--usage
      new webpack.optimize.OccurenceOrderPlugin(),
      new webpack.HotModuleReplacementPlugin(),
      new webpack.NoErrorsPlugin(),
      // https://github.com/ampedandwired/html-webpack-plugin
      new HtmlWebpackPlugin({
        filename: 'index.html',
        template: 'index.html',
        inject: true
      })
    ]
  })
}
